<template>
    <HcPageLayout>
        <template #left>
            <div class="hc-layout-tree-box">
                <el-scrollbar>
                    <HcTreeData @nodeTap="treeNodeTap" />
                </el-scrollbar>
            </div>
        </template>
        <HcCard>
            <template #header>
                <div class="w-52">
                    <el-input v-model="searchForm.name" clearable placeholder="请输入名称进行查询" size="large" />
                </div>
                <div class="ml-4">
                    <el-button type="primary" size="large" @click="searchClick">
                        <HcIcon name="search-2" />
                        <span>搜索</span>
                    </el-button>
                </div>
            </template>
            <template #extra>
                <el-button size="large" type="primary" hc-btn @click="addRowClick">
                    <HcIcon name="add" />
                    <span>新增</span>
                </el-button>
                <el-button size="large" type="warning" hc-btn>
                    <HcIcon name="add" />
                    <span>打印</span>
                </el-button>
                <el-button size="large" type="danger" hc-btn :disabled="tableCheckedKeys.length < 1" @click="batchDel">
                    <HcIcon name="delete-bin" />
                    <span>删除</span>
                </el-button>
            </template>
            <HcTable :column="tableColumn" :datas="tableData" :loading="tableLoading" is-check @selection-change="tableSelectionChange">
                <template #action="{ row, index }">
                    <el-button size="small" type="primary" :disabled="row?.isQuote === 1" @click="editRowClick(row)">
                        修改
                    </el-button>
                    <el-button size="small" type="warning" @click="viewPdf(row)">
                        查看
                    </el-button>
                    <el-button size="small" type="danger" :disabled="row?.isQuote === 1" @click="delAgree(row)">
                        删除
                    </el-button>
                </template>
            </HcTable>
            <template #action>
                <HcPages :pages="searchForm" @change="pageChange" />
            </template>
        </HcCard>
    </HcPageLayout>
</template>

<script setup>
import { onActivated, ref } from 'vue'
import { useRouter } from 'vue-router'
import landApi from '~api/agree/land.js'
import { useAppStore } from '~src/store'
import { arrToId, getArrValue } from 'js-fast-way'
import { delMessageV2 } from '~com/message/index.js'
const useAppState = useAppStore()
const projectId = ref(useAppState.getProjectId)
const router = useRouter()
const areaId = ref('')
//树节点被点击
const treeNodeTap = ({ node, data }) => {
    areaId.value = data.id
    searchForm.value.areaId = data.id
    getTableData()
}
onActivated(()=>{
    getTableData()
})
//搜索表单
const searchForm = ref({
    projectType: null, name: null, startTime: null, endTime: null,
    current: 1, size: 20, total: 0,
})

//搜索
const searchClick = () => {
    searchForm.value.current = 1
    getTableData()
}

//分页被点击
const pageChange = ({ current, size }) => {
    searchForm.value.current = current
    searchForm.value.size = size
    getTableData()
}

//获取数据
const tableLoading = ref(false)
const tableColumn = [
    { key: 'number', name: '协议编号' },
    { key: 'name', name: '协议书名称' },
    { key: 'landMoney', name: '地类补偿金额' },
    { key: 'cropsMoney', name: '青苗及附着物补偿金额' },
    { key: 'allMoney', name: '补偿总金额' },
    { key: 'action', name: '操作', width: '190', align: 'center' },
]
const tableData = ref([

])
const getTableData = async () => {
    tableLoading.value = true
    const { error, code, data } = await landApi.getPage({
        ...searchForm.value,
        projectId: projectId.value,
        type:1,
    })
    tableLoading.value = false
    if (!error && code === 200) {
        tableData.value = getArrValue(data['records'])
        searchForm.value.total = data['total'] || 0
    } else {
        tableData.value = []
        searchForm.value.total = 0
    }
}

//多选事件
const tableCheckedKeys = ref([])
const tableSelectionChange = (rows) => {
    tableCheckedKeys.value = rows
}

//新增
const addRowClick = () => {
if (searchForm.value.areaId) {
    router.push({
        name: 'lar-agree-land-form',
        query:{
            type:1,
            areaId:areaId.value,
        },
    })
} else {
    window.$message.warning('请先选择左侧节点')
}
   
}

//编辑
const editRowClick = (row) => {
    router.push({
        name: 'lar-agree-land-form',
        query:{
            type:2,
            id:row.id,
            areaId:areaId.value,
        },
    })
}
//查看pdf
const viewPdf = ({ mergePdfUrl }) => {
    if (mergePdfUrl) {
        window.open(mergePdfUrl, '_blank')
    } else {
        window.$message.error('暂无文件')
    }
}
const delAgree = (row)=>{
    delMessageV2(async (action, instance, done) => {
            if (action === 'confirm') {
                instance.confirmButtonLoading = true
                const { error, code, msg } = await landApi.remove({
                            ids: row?.id,
                        })
                        if (!error && code === 200) {
                            window?.$message?.success('删除成功')
                            getTableData()
                        } else {
                            window?.$message?.warning(msg)
                        }
                instance.confirmButtonLoading = false
                done()
            } else {
                done()
            }
     })
}
const batchDel = ()=>{
    const rows = tableCheckedKeys.value
    const ids = arrToId(rows)
    delMessageV2(async (action, instance, done) => {
            if (action === 'confirm') {
                instance.confirmButtonLoading = true
                const { error, code, msg } = await landApi.remove({
                            ids,
                        })
                        if (!error && code === 200) {
                            window?.$message?.success('删除成功')
                            getTableData()
                        } else {
                            window?.$message?.warning(msg)
                        }
                instance.confirmButtonLoading = false
                done()
            } else {
                done()
            }
     })
}
</script>

<style lang="scss" scoped>
.hc-layout-tree-box {
    position: relative;
    height: 100%;
    padding: 18px;
}
</style>
